#include<stdio.h>
#include<stdlib.h>
#include "llist.h"

void print_node_at(NODE *head, int pos){
	NODE *currentNode;

	currentNode = head;

	for (int i = 0; i<pos; i++){
		currentNode = currentNode->next;
	}
	printf("The data at index %d is: %d\n", pos, currentNode->data);
}

void print_node(NODE *head){
	printf("%d\n", head->data);}

void print_list(NODE *head){
//	printf("Printing list...\n");

	NODE *currentNode;
	currentNode = head;

	int i = 0;

	while (currentNode != NULL){
		printf("Index: %d; Data: %d\n",i,currentNode->data);
		currentNode=currentNode->next;
		i++;
	}
}

NODE_ERR psearch(NODE *head, datatype data){
	printf("Searching list for: %d\n", data);
	NODE_ERR node = search(head, data);
	if(node.node != NULL)
		printf("Location found, index: %d.\n", node.err);
	else
		puts("Not found in this list.");
	return node;
}

NODE_ERR search(NODE *head, datatype data){
	NODE_ERR curr;
	curr.node = head;
	int i;
	for(i=0;curr.node != NULL;i++){
		if(curr.node->data == data){
			curr.err=i;
			return curr;
		}
		curr.node=curr.node->next;
	}
	curr.node = NULL;
	curr.err = -1;
	return curr;
}

NODE *construct(datatype data, NODE *next){
	NODE *out = malloc(sizeof(NODE));
	if(out != NULL){
		out->data = data;
		out->next = next;
	}
	return out;
}

NODE *traverse(NODE *head, int pos){
	if(head==NULL)
		return NULL;
	int i;
	for(i=0;i<pos || pos<0;i++){
		if(head->next != NULL)
			head = head->next;
		else
			break;
	}
	return head;
}

int delete_node_after(NODE *head){
	if(head==NULL || head->next == NULL)
		return 1;
	NODE* tmp = head->next;
	head->next = head->next->next;
	free(tmp);
	return 0;
}

void delete_list(NODE *head){
	if(head == NULL)
		return;
	NODE *tmp = head->next;
	free(head);
	delete_list(tmp);
}

NODE *construct_list(datatype list[], int size){
	if(size<=0)
		return NULL;
	NODE *next = construct(list[size-1],NULL);
	NODE *head;
	int i;
	for(i=size-2;i>=0;i--){
		head = next;
		next = construct(list[i],head);
		if(next == NULL)
			delete_list(head);
	}
	return next;
}

int add_to_end(NODE *head, datatype new_data){
	return insert_node(head, -1, new_data);
}

int insert_node(NODE *head, int pos, datatype new_data){
	if(head==NULL)
		return 1;
	if(pos!=0)
		return insert_node_after(traverse(head,pos-1),new_data);
	else{
		int out = insert_node_after(head,head->data);
		if(out>0)
			return out;
		head->data = new_data;
	}
	return 0;
}

int insert_node_after(NODE *head, datatype data){
	if(head==NULL)
		return 1;
	NODE *new = construct(data, head->next);
	if(new == NULL)
		return 2;
	head->next = new;
	return 0;
}


int length(NODE *head){
	if(head==NULL)
		return 0;
	int i=1;
	while((head=head->next) != NULL)
		i++;
	return i;
}
